
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Payment_transactionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const payment_transactions = await db.payment_transactions.create(
            {
                id: data.id || undefined,
        
        transaction_type: data.transaction_type
        ||
        null
            ,
            
        transaction_status: data.transaction_status
        ||
        null
            ,
            
        amount: data.amount
        ||
        null
            ,
            
        currency: data.currency
        ||
        null
            ,
            
        provider: data.provider
        ||
        null
            ,
            
        provider_reference: data.provider_reference
        ||
        null
            ,
            
        processed_at: data.processed_at
        ||
        null
            ,
            
        failure_reason: data.failure_reason
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await payment_transactions.setOrder( data.order || null, {
            transaction,
        });
        
        await payment_transactions.setBuyer_tenant( data.buyer_tenant || null, {
            transaction,
        });
        
        await payment_transactions.setSeller_tenant( data.seller_tenant || null, {
            transaction,
        });
        
        await payment_transactions.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return payment_transactions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const payment_transactionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                transaction_type: item.transaction_type
            ||
            null
            ,
            
                transaction_status: item.transaction_status
            ||
            null
            ,
            
                amount: item.amount
            ||
            null
            ,
            
                currency: item.currency
            ||
            null
            ,
            
                provider: item.provider
            ||
            null
            ,
            
                provider_reference: item.provider_reference
            ||
            null
            ,
            
                processed_at: item.processed_at
            ||
            null
            ,
            
                failure_reason: item.failure_reason
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const payment_transactions = await db.payment_transactions.bulkCreate(payment_transactionsData, { transaction });

        // For each item created, replace relation files
        

        return payment_transactions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const payment_transactions = await db.payment_transactions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.transaction_type !== undefined) updatePayload.transaction_type = data.transaction_type;
        
        
        if (data.transaction_status !== undefined) updatePayload.transaction_status = data.transaction_status;
        
        
        if (data.amount !== undefined) updatePayload.amount = data.amount;
        
        
        if (data.currency !== undefined) updatePayload.currency = data.currency;
        
        
        if (data.provider !== undefined) updatePayload.provider = data.provider;
        
        
        if (data.provider_reference !== undefined) updatePayload.provider_reference = data.provider_reference;
        
        
        if (data.processed_at !== undefined) updatePayload.processed_at = data.processed_at;
        
        
        if (data.failure_reason !== undefined) updatePayload.failure_reason = data.failure_reason;
        
        
        updatePayload.updatedById = currentUser.id;

        await payment_transactions.update(updatePayload, {transaction});

        
        
        if (data.order !== undefined) {
            await payment_transactions.setOrder(
              
              data.order,
              
              { transaction }
            );
        }
        
        if (data.buyer_tenant !== undefined) {
            await payment_transactions.setBuyer_tenant(
              
              data.buyer_tenant,
              
              { transaction }
            );
        }
        
        if (data.seller_tenant !== undefined) {
            await payment_transactions.setSeller_tenant(
              
              data.seller_tenant,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await payment_transactions.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return payment_transactions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const payment_transactions = await db.payment_transactions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of payment_transactions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of payment_transactions) {
                await record.destroy({transaction});
            }
        });


        return payment_transactions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const payment_transactions = await db.payment_transactions.findByPk(id, options);

        await payment_transactions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await payment_transactions.destroy({
            transaction
        });

        return payment_transactions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const payment_transactions = await db.payment_transactions.findOne(
            { where },
            { transaction },
        );

        if (!payment_transactions) {
            return payment_transactions;
        }

        const output = payment_transactions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.order = await payment_transactions.getOrder({
            transaction
        });
        
        
        output.buyer_tenant = await payment_transactions.getBuyer_tenant({
            transaction
        });
        
        
        output.seller_tenant = await payment_transactions.getSeller_tenant({
            transaction
        });
        
        
        output.organizations = await payment_transactions.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.orders,
        as: 'order',
        
        where: filter.order ? {
          [Op.or]: [
            { id: { [Op.in]: filter.order.split('|').map(term => Utils.uuid(term)) } },
            {
              order_number: {
                [Op.or]: filter.order.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.tenants,
        as: 'buyer_tenant',
        
        where: filter.buyer_tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.buyer_tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              tenant_name: {
                [Op.or]: filter.buyer_tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.tenants,
        as: 'seller_tenant',
        
        where: filter.seller_tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.seller_tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              tenant_name: {
                [Op.or]: filter.seller_tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.currency) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'payment_transactions',
                        'currency',
                        filter.currency,
                    ),
                };
            }
            
            if (filter.provider) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'payment_transactions',
                        'provider',
                        filter.provider,
                    ),
                };
            }
            
            if (filter.provider_reference) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'payment_transactions',
                        'provider_reference',
                        filter.provider_reference,
                    ),
                };
            }
            
            if (filter.failure_reason) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'payment_transactions',
                        'failure_reason',
                        filter.failure_reason,
                    ),
                };
            }
            

            
            

            
            if (filter.amountRange) {
                const [start, end] = filter.amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.processed_atRange) {
                const [start, end] = filter.processed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    processed_at: {
                    ...where.processed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    processed_at: {
                    ...where.processed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.transaction_type) {
                where = {
                    ...where,
                transaction_type: filter.transaction_type,
            };
            }
            
            if (filter.transaction_status) {
                where = {
                    ...where,
                transaction_status: filter.transaction_status,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.payment_transactions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'payment_transactions',
                        'provider_reference',
                        query,
                    ),
                ],
            };
        }

        const records = await db.payment_transactions.findAll({
            attributes: [ 'id', 'provider_reference' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['provider_reference', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.provider_reference,
        }));
    }

    
};

